
"""

unittests for python modules in tomte project

run all tests:
   python test.py

run single test :
   # it is needed you cd to this directory, and then :
   python -m unittest test.TestCompare.test_compare

"""

import unittest

import os, sys

# add parentdir of python scriptdir  to the python path
script_dir=os.path.abspath(os.path.dirname(sys.argv[0]))
python_script_dir=os.path.abspath(script_dir+'/../')
sys.path.insert(0, python_script_dir)

import compare
import uppaal2bcg

class TestCompare(unittest.TestCase):
     def setUp(self):
         self.modelfile1=script_dir + "/learnedModel.xml"
         self.modelfile2=script_dir + "/sut.xml"

     def test_compare(self):
           global CONFIG
           CONFIG=uppaal2bcg.settings([script_dir + '/../'] )
           result=compare.compare(self.modelfile1,self.modelfile2,0,0,False)
           self.assertTrue( result.strip().endswith('TRUE') )

     def test_remote_compare(self):
           global CONFIG
           CONFIG=uppaal2bcg.settings([script_dir + '/../'] )
           result=compare.compare(self.modelfile1,self.modelfile2,0,0,False)
           self.assertTrue( result.strip().endswith('TRUE') )

if __name__ == '__main__':
    #unittest.main()
    suite = unittest.TestSuite()

    suite.addTest(TestCompare("test_compare"))
    unittest.TextTestRunner().run(suite)
